Summary: Libraries for distributed computing.
Name: pvm 
Version: 3.4.3
Release: 4
Copyright: freely distributable
Group: Development/Libraries
Source0: http://www.epm.ornl.gov/%7ekohl/PVM/pvm3.4.3.tgz 
Source1: http://www.netlib.org/pvm3/xpvm/XPVM.src.1.2.5.tgz
Source2: xpvm.sh
Source3: pvmd.init
Source4: pvm.sh
Patch0: xpvm.patch
BuildRoot: /var/tmp/pvm-root

%package gui
Requires: pvm
Summary: TCL/TK graphical frontend to monitor and manage a PVM cluster.
Group: Applications/System

%description
PVM3 (Parallel Virtual Machine) is a library and daemon that allows
distributed processing environments to be constructed on heterogeneous
machines and architectures.

%description gui
Xpvm is a TCL/TK based tool that allows full manageability of the PVM cluster
as well as the ability to monitor cluster performance.

%prep
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/share/
cd $RPM_BUILD_ROOT/usr/share
tar -xzf %{SOURCE0}
cd pvm3
tar -xzf %{SOURCE1}
%patch0 -p0

%build
PVM_ROOT=$RPM_BUILD_ROOT/usr/share/pvm3 \
	PVM_DPATH=$RPM_BUILD_ROOT/usr/share/pvm3/lib/pvmd \
	make -C $RPM_BUILD_ROOT/usr/share/pvm3 
PVM_ROOT=$RPM_BUILD_ROOT/usr/share/pvm3 \
	XPVM_ROOT=$RPM_BUILD_ROOT/usr/share/pvm3/xpvm \
	make -C $RPM_BUILD_ROOT/usr/share/pvm3/xpvm

%install
mkdir -p $RPM_BUILD_ROOT/usr/man/man{1,3}
install -m 644 $RPM_BUILD_ROOT/usr/share/pvm3/man/man1/* $RPM_BUILD_ROOT/usr/man/man1
install -m 644 $RPM_BUILD_ROOT/usr/share/pvm3/man/man3/* $RPM_BUILD_ROOT/usr/man/man3
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 0755 -o root -g root $RPM_SOURCE_DIR/xpvm.sh $RPM_BUILD_ROOT/usr/bin/xpvm
PVM_ROOT=$RPM_BUILD_ROOT/usr/share/pvm3 \
	XPVM_ROOT=$RPM_BUILD_ROOT/usr/share/pvm3/xpvm \
	make -C $RPM_BUILD_ROOT/usr/share/pvm3/xpvm install
strip $RPM_BUILD_ROOT/usr/share/pvm3/bin/*/*

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 0755 -o root -g root $RPM_SOURCE_DIR/pvmd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/pvmd

mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 0755 -o root -g root $RPM_SOURCE_DIR/pvm.sh $RPM_BUILD_ROOT/usr/bin/pvm

# build the file list
find $RPM_BUILD_ROOT -type f -o -type l | \
	sed -e "s|$RPM_BUILD_ROOT||g" | \
	grep -v -i win32 | \
	grep -v "/pvm3/man/man." | \
        grep -v "usr/man" | \
        grep -v "xpvm" | \
	grep -v "example" | \
	grep -v "conf/" | \
	grep -v "etc/rc.d" | \
	grep -v "\.o$" > files.list
find $RPM_BUILD_ROOT -type f -o -type l | \
	sed -e "s|$RPM_BUILD_ROOT||g" | \
	grep "conf/LINUX" >> files.list
find $RPM_BUILD_ROOT -type f -o -type l | \
	grep example | \
	sed -e "s|$RPM_BUILD_ROOT|%doc |g" >> files.list
find $RPM_BUILD_ROOT/usr/share/pvm3  -type d | \
	sed -e "s|$RPM_BUILD_ROOT|%dir |g" | \
	grep -v "xpvm" >> files.list

%clean
rm -rf $RPM_BUILD_ROOT
rm -f files.list

%pre
/usr/sbin/groupadd -g 24 -r -f pvm > /dev/null 2>&1 ||:
/usr/sbin/useradd -u 24 -g 24 -d /usr/share/pvm3 -r -s /bin/bash pvm > /dev/null 2>&1 ||:
 
%preun
if [ $1 = 0 ]; then
        /sbin/chkconfig --del pvmd
fi
	
%post
/sbin/chkconfig --add pvmd

%postun
if [ $1 = 0 ] ; then
        userdel pvm > /dev/null 2>&1
fi

%files -f files.list
%defattr(-,root,root)
%config /etc/rc.d/init.d/pvmd
/usr/man*/*

%files gui
%defattr(-,root,root)
%dir /usr/share/pvm3/xpvm/
/usr/share/pvm3/bin/*/xpvm
/usr/bin/xpvm
/usr/share/pvm3/xpvm/*

%changelog
* Mon Mar 06 2000 Mike Wangsmo <wanger@redhat.com>
- fixed the useradd failure mode when user already exists
- finally, the init script seems to behave nicely as user pvm

* Sun Mar 05 2000 Mike Wangsmo <wanger@redhat.com>
- fixed quirk in init script to allow PVMD_NOHOLD=ON to be honored

* Fri Feb 18 2000 Mike Wangsmo <wanger@redhat.com>
- added env. variable to make pvmd background when started
- fixed init script killproc errors
- moved to 3.4.3 proper

* Tue Feb 15 2000 Mike Wangsmo <wanger@redhat.com>
- fixed up some group ID stuff

* Mon Feb 14 2000 Mike Wangsmo <wanger@redhat.com>
- added pvm user to package

* Wed Feb 09 2000 Mike Wangsmo <wanger@redhat.com>
- added sparc64 identifier to pvmgetarch
- configured pvmd within the init script to run as user pvm

* Sat Feb 05 2000 Mike Wangsmo <wanger@redhat.com>
- changed pvm-gui group
- set chkconfig to be off in all run levels as the default

* Thu Feb 04 2000 Mike Wangsmo <wanger@redhat.com>
- added sysV init script
- added a shell wrapper in /usr/bin for the pvm shell
- moved up to 3.4.2pl4

* Wed Feb 02 2000 Mike Wangsmo <wanger@redhat.com>
- added some missing files for xpvm to work

* Mon Jan 24 2000 Mike Wangsmo <wanger@redhat.com>
- dropped all non-linux stuff
- split the packages up
- added xpvm
- "fixed" Sparc

* Mon Nov 29 1999 Tim Powers <timp@redhat.com>
- updated to 3.4.2

* Sun Sep 5 1999 Tim Powers <timp@redhat.com>
- excludearch sparc

* Wed Jul 28 1999 Tim Powers <timp@redhat.com>
- update to 3.4.1
- comment out the patches in %prep section, will test, if it works then it
  stays commented

* Wed May 05 1999 Bill Nottingham <notting@redhat.com>
- update to 3.4.0 final

* Tue Oct 27 1998 Cristian Gafton <gafton@redhat.com>
- added a patch for the SIGCLD -> SIGCHLD rename
- fixed the incredibly stupid spec file to have a much shorter %files list

* Tue Oct 12 1998 Michael Maher <mike@redhat.com>
- updated pacakge for 5.2 powertools.

* Sat Jun 06 1998 Michael Maher <mike@redhat.com>
- updated source
- changed spec file for all archs

* Wed Dec 03 1997 Mike Wangsmo <wanger@redhat.com>
- fixed patches to cleanly build on glibc
- corrected alpha inuendos

* Wed Dec  3 1997 Otto Hammersmith <otto@redhat.com>
- snagged Wanger's package.
- moved buildroot from /var/tmp to /var/tmp/pvm-root

